com.pixelmed.apps

## Class SynchronizeFromRemoteSCP

- java.lang.Object
- - com.pixelmed.apps.SynchronizeFromRemoteSCP

    public class SynchronizeFromRemoteSCP
    extends java.lang.Object

A class for synchronizing the contents of a local database of DICOM objects with a remote SCP.

The class has no public methods other than the constructor and a main method that is useful as a utility. The constructor establishes an association, sends hierarchical C-FIND requests at the STUDY, SERIES and IMAGE levels to determine what is available on the remote AE, then attempts to retrieve anything not present locally at the highest level possible. E.g., if a study is not present, a retrieve of the entire study is requested.

The main method is also useful in its own right as a command-line utility. For example:

    java -cp ./pixelmed.jar:./lib/additional/hsqldb.jar:./lib/additional/commons-codec-1.3.jar:./lib/additional/jmdns.jar \
            com.pixelmed.apps.SynchronizeFromRemoteSCP \
            /tmp/dicomsync/database /tmp/dicomsync \
            graytoo 4006 GRAYTOO_DIV_4006 \
            11112 US \
            MOVE ALL 1 0

### Constructor Summary

Constructors
Constructor and Description

`SynchronizeFromRemoteSCP(DatabaseInformationModel databaseInformationModel, java.io.File savedInstancesFolder, java.lang.String remoteHost, int remotePort, java.lang.String remoteAE, int localPort, java.lang.String localAE, boolean useGet, boolean queryAll, int verbosityLevel, int debugLevel, boolean anyTransferSyntax)`
Synchronize the contents of a local database of DICOM objects with a remote SCP.

### Method Summary

Methods
`static void` `main(java.lang.String[] arg)` Synchronize the contents of a local database of DICOM objects with a remote SCP.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### SynchronizeFromRemoteSCP

    public SynchronizeFromRemoteSCP(DatabaseInformationModel databaseInformationModel,
                            java.io.File savedInstancesFolder,
                            java.lang.String remoteHost,
                            int remotePort,
                            java.lang.String remoteAE,
                            int localPort,
                            java.lang.String localAE,
                            boolean useGet,
                            boolean queryAll,
                            int verbosityLevel,
                            int debugLevel,
                            boolean anyTransferSyntax)
                             throws DicomException,
                                    DicomNetworkException,
                                    java.io.IOException,
                                    java.lang.InterruptedException

Synchronize the contents of a local database of DICOM objects with a remote SCP.

Queries the remote SCP for everything it has and retrieves all instances not already present in the specified local database.

Parameters:
  `databaseInformationModel` - the local database (will be created if does not already exist)
  `savedInstancesFolder` - where to save retrieved instances (must already exist)
  `remoteHost` -
  `remotePort` -
  `remoteAE` -
  `localPort` - local port for DICOM listener ... must already be known to remote AE unless C-GET
  `localAE` - local AET for DICOM listener ... must already be known to remote AE unless C-GET
  `useGet` - if true, use C-GET rather than C-MOVE
  `queryAll` - if true query for all patient names at once, rather than selectively by first letter
  `verbosityLevel` -
  `debugLevel` -
  `anyTransferSyntax` - if true, accept any Transfer Syntax, not just uncompressed ones
Throws:
  `DicomException`
  `DicomNetworkException`
  `java.io.IOException`
  `java.lang.InterruptedException`

### Method Detail

#### main

    public static void main(java.lang.String[] arg)

Synchronize the contents of a local database of DICOM objects with a remote SCP.

Queries the remote SCP for everything it has and retrieves all instances not already present in the specified local database.

Will register the supplied local AE and port with Bonjour if supported (this is specific to the main() method; the constructor of the class itself does not do this).

Parameters:
  `arg` - array of 7, 8, 9, 10 or 11 strings - the fully qualified path of the database file prefix, the fully qualified path of the saved incoming files folder, the remote hostname, remote port, remote AE Title, our port (ignored if GET), our AE Title, optionally GET or MOVE (defaults to MOVE), optionally query by ALL or SELECTIVE patient name (defaults to ALL), optionally a verbosity level, optionally an integer debug level, optionally UNCOMPRESSED or ANY (defaults to UNCOMPRESSED)